/*

  Owner button demo
  ver. 2017-01-23

*/

#include "hmg.ch"

#define IDC_BTN_1   1001
#define IDC_BTN_2   1002
#define IDC_BTN_3   1003
#define IDC_BTN_4   1004
#define IDC_BTN_5   1005
#define IDC_BTN_6   1006
#define IDC_BTN_YES 1101
#define IDC_BTN_NO  1102
#define IDC_BTN_OK  1201


FUNCTION Main()
  LOCAL aBtnColor1
  LOCAL aBtnColor2
  LOCAL aBtnFont

  DEFINE WINDOW Form1;
    MAIN;
    WIDTH  380;
    HEIGHT 520;
    TITLE  "Owner buttons demo";
    NOSIZE;
    NOMAXIMIZE

    DEFINE MAINMENU
      DEFINE POPUP "BTN &1"
        MENUITEM "Move"                     ACTION MoveButton("Form1", IDC_BTN_1)
        MENUITEM "Resize"                   ACTION ResizeButton("Form1", IDC_BTN_1)
        SEPARATOR
        MENUITEM "Show"                     ACTION ShowButton("Form1", IDC_BTN_1, .T.)
        MENUITEM "Hide"                     ACTION ShowButton("Form1", IDC_BTN_1, .F.)
        SEPARATOR
        MENUITEM "Enable"                   ACTION EnableButton("Form1", IDC_BTN_1, .T.)
        MENUITEM "Disable"                  ACTION EnableButton("Form1", IDC_BTN_1, .F.)
        SEPARATOR
        MENUITEM "Change shape"             ACTION ChangeButtonShape("Form1", IDC_BTN_1)
        MENUITEM "Change caption"           ACTION ChangeButtonCaption("Form1", IDC_BTN_1)
        MENUITEM "Change caption alignment" ACTION ChangeButtonCaptionAlign("Form1", IDC_BTN_1)
        MENUITEM "Change font"              ACTION ChangeButtonFont("Form1", IDC_BTN_1)
        SEPARATOR
        MENUITEM "Set focus"                ACTION SetFocusToButton("Form1", IDC_BTN_1)
        MENUITEM "Release"                  ACTION ReleaseButton("Form1", IDC_BTN_1)
      END POPUP
      DEFINE POPUP "BTN &2"
        MENUITEM "Move"                     ACTION MoveButton("Form1", IDC_BTN_2)
        MENUITEM "Resize"                   ACTION ResizeButton("Form1", IDC_BTN_2)
        SEPARATOR
        MENUITEM "Show"                     ACTION ShowButton("Form1", IDC_BTN_2, .T.)
        MENUITEM "Hide"                     ACTION ShowButton("Form1", IDC_BTN_2, .F.)
        SEPARATOR
        MENUITEM "Enable"                   ACTION EnableButton("Form1", IDC_BTN_2, .T.)
        MENUITEM "Disable"                  ACTION EnableButton("Form1", IDC_BTN_2, .F.)
        SEPARATOR
        MENUITEM "Change shape"             ACTION ChangeButtonShape("Form1", IDC_BTN_2)
        MENUITEM "Change caption"           ACTION ChangeButtonCaption("Form1", IDC_BTN_2)
        MENUITEM "Change caption alignment" ACTION ChangeButtonCaptionAlign("Form1", IDC_BTN_2)
        MENUITEM "Change font"              ACTION ChangeButtonFont("Form1", IDC_BTN_2)
        SEPARATOR
        MENUITEM "Set focus"                ACTION SetFocusToButton("Form1", IDC_BTN_2)
        MENUITEM "Release"                  ACTION ReleaseButton("Form1", IDC_BTN_2)
      END POPUP
      DEFINE POPUP "BTN &3"
        MENUITEM "Move"                     ACTION MoveButton("Form1", IDC_BTN_3)
        MENUITEM "Resize"                   ACTION ResizeButton("Form1", IDC_BTN_3)
        SEPARATOR
        MENUITEM "Show"                     ACTION ShowButton("Form1", IDC_BTN_3, .T.)
        MENUITEM "Hide"                     ACTION ShowButton("Form1", IDC_BTN_3, .F.)
        SEPARATOR
        MENUITEM "Enable"                   ACTION EnableButton("Form1", IDC_BTN_3, .T.)
        MENUITEM "Disable"                  ACTION EnableButton("Form1", IDC_BTN_3, .F.)
        SEPARATOR
        MENUITEM "Change shape"             ACTION ChangeButtonShape("Form1", IDC_BTN_3)
        MENUITEM "Change caption"           ACTION ChangeButtonCaption("Form1", IDC_BTN_3)
        MENUITEM "Change caption alignment" ACTION ChangeButtonCaptionAlign("Form1", IDC_BTN_3)
        MENUITEM "Change font"              ACTION ChangeButtonFont("Form1", IDC_BTN_3)
        SEPARATOR
        MENUITEM "Set focus"                ACTION SetFocusToButton("Form1", IDC_BTN_3)
        MENUITEM "Release"                  ACTION ReleaseButton("Form1", IDC_BTN_3)
      END POPUP
      DEFINE POPUP "BTN &4"
        MENUITEM "Move"                     ACTION MoveButton("Form1", IDC_BTN_4)
        MENUITEM "Resize"                   ACTION ResizeButton("Form1", IDC_BTN_4)
        SEPARATOR
        MENUITEM "Show"                     ACTION ShowButton("Form1", IDC_BTN_4, .T.)
        MENUITEM "Hide"                     ACTION ShowButton("Form1", IDC_BTN_4, .F.)
        SEPARATOR
        MENUITEM "Enable"                   ACTION EnableButton("Form1", IDC_BTN_4, .T.)
        MENUITEM "Disable"                  ACTION EnableButton("Form1", IDC_BTN_4, .F.)
        SEPARATOR
        MENUITEM "Change shape"             ACTION ChangeButtonShape("Form1", IDC_BTN_4)
        MENUITEM "Change caption"           ACTION ChangeButtonCaption("Form1", IDC_BTN_4)
        MENUITEM "Change caption alignment" ACTION ChangeButtonCaptionAlign("Form1", IDC_BTN_4)
        MENUITEM "Change font"              ACTION ChangeButtonFont("Form1", IDC_BTN_4)
        SEPARATOR
        MENUITEM "Set focus"                ACTION SetFocusToButton("Form1", IDC_BTN_4)
        MENUITEM "Release"                  ACTION ReleaseButton("Form1", IDC_BTN_4)
      END POPUP
      DEFINE POPUP "BTN &5"
        MENUITEM "Move"                     ACTION MoveButton("Form1", IDC_BTN_5)
        MENUITEM "Resize"                   ACTION ResizeButton("Form1", IDC_BTN_5)
        SEPARATOR
        MENUITEM "Show"                     ACTION ShowButton("Form1", IDC_BTN_5, .T.)
        MENUITEM "Hide"                     ACTION ShowButton("Form1", IDC_BTN_5, .F.)
        SEPARATOR
        MENUITEM "Enable"                   ACTION EnableButton("Form1", IDC_BTN_5, .T.)
        MENUITEM "Disable"                  ACTION EnableButton("Form1", IDC_BTN_5, .F.)
        SEPARATOR
        MENUITEM "Change shape"             ACTION ChangeButtonShape("Form1", IDC_BTN_5)
        MENUITEM "Change caption"           ACTION ChangeButtonCaption("Form1", IDC_BTN_5)
        MENUITEM "Change caption alignment" ACTION ChangeButtonCaptionAlign("Form1", IDC_BTN_5)
        MENUITEM "Change font"              ACTION ChangeButtonFont("Form1", IDC_BTN_5)
        SEPARATOR
        MENUITEM "Set focus"                ACTION SetFocusToButton("Form1", IDC_BTN_5)
        MENUITEM "Release"                  ACTION ReleaseButton("Form1", IDC_BTN_5)
      END POPUP
      DEFINE POPUP "BTN &6"
        MENUITEM "Move"                     ACTION MoveButton("Form1", IDC_BTN_6)
        MENUITEM "Resize"                   ACTION ResizeButton("Form1", IDC_BTN_6)
        SEPARATOR
        MENUITEM "Show"                     ACTION ShowButton("Form1", IDC_BTN_6, .T.)
        MENUITEM "Hide"                     ACTION ShowButton("Form1", IDC_BTN_6, .F.)
        SEPARATOR
        MENUITEM "Enable"                   ACTION EnableButton("Form1", IDC_BTN_6, .T.)
        MENUITEM "Disable"                  ACTION EnableButton("Form1", IDC_BTN_6, .F.)
        SEPARATOR
        MENUITEM "Change shape"             ACTION ChangeButtonShape("Form1", IDC_BTN_6)
        MENUITEM "Change caption"           ACTION ChangeButtonCaption("Form1", IDC_BTN_6)
        MENUITEM "Change caption alignment" ACTION ChangeButtonCaptionAlign("Form1", IDC_BTN_6)
        MENUITEM "Change font"              ACTION ChangeButtonFont("Form1", IDC_BTN_6)
        SEPARATOR
        MENUITEM "Set focus"                ACTION SetFocusToButton("Form1", IDC_BTN_6)
        MENUITEM "Release"                  ACTION ReleaseButton("Form1", IDC_BTN_6)
      END POPUP
      DEFINE POPUP "&All buttons"
        MENUITEM "Background &1" ACTION ChangeButtonColorAll("Form1", 1)
        MENUITEM "Background &2" ACTION ChangeButtonColorAll("Form1", 2)
        MENUITEM "Background &3" ACTION ChangeButtonColorAll("Form1", 3)
        MENUITEM "Background &4" ACTION ChangeButtonColorAll("Form1", 4)
      END POPUP
    END MENU
  END WINDOW

  aBtnColor1 := {{0xFF0000, 0x000000, 0x00FFFF, 0x0090C0, 0}, NIL, {0x0000FF, 0x000000, 0x00FF00, 0x00A000, 0}}
  aBtnColor2 := {{0xFF0000, 0x000000, 0, 0, 0, "MUSIC1E"}, {NIL, NIL, 0, 0, 0, "MUSIC1D"}, {0x0000FF, 0x000000, 0, 0, 0, "MUSIC1F"}}
  aBtnFont   := {"Arial", 9, .F., .F., .F., .F.}

  OBTN_Create("Form1", IDC_BTN_1, "button &1",                     10, 20, 120,  30, .T., .T., .T.,  0, aBtnColor1, aBtnFont)
  OBTN_Create("Form1", IDC_BTN_2, "button &2",                     50, 20, 120,  30, .T., .T., .T.,  8, aBtnColor1, aBtnFont)
  OBTN_Create("Form1", IDC_BTN_3, "button &3",                     90, 20, 120,  30, .T., .T., .T., 30, aBtnColor1, aBtnFont)
  OBTN_Create("Form1", IDC_BTN_4, e"button &4\nmultiline",        130, 20, 120,  60, .T., .T., .T.,  8, aBtnColor1, aBtnFont)
  OBTN_Create("Form1", IDC_BTN_5, e"button &5\ncircular\n<quit>", 200, 20, 120, 120, .T., .T., .T., -1, aBtnColor1, aBtnFont)
  OBTN_Create("Form1", IDC_BTN_6, {e"button &6\nmusic", "CB"},    330, 20, 120, 120, .T., .T., .T., -1, aBtnColor2, aBtnFont)

  InstallEventHandler("EventHandler")

  Form1.CENTER
  Form1.ACTIVATE

RETURN NIL


FUNCTION EventHandler(nHWnd, nMsg, nWParam, nLParam)
  LOCAL nID

  IF nHWnd == Form1.HANDLE
    IF nMsg == 43 //WM_DRAWITEM
      IF (nWParam >= IDC_BTN_1) .and. (nWParam <= IDC_BTN_6)
        OBTN_Draw(nHWnd, nWParam, nLParam)
      ENDIF

    ELSEIF nMsg == 273 //WM_COMMAND
      nID := LoWord(nWParam)

      IF nID == IDOK
        nID := GetDlgCtrlID(GetFocus())
      ENDIF

      SWITCH nID
        CASE IDC_BTN_1
          MessageBoxInfo("Button 1 was pressed.")
          EXIT
        CASE IDC_BTN_2
          MessageBoxInfo("Button 2 was pressed.")
          EXIT
        CASE IDC_BTN_3
          MessageBoxInfo("Button 3 was pressed.")
          EXIT
        CASE IDC_BTN_4
          MessageBoxInfo("Button 4 was pressed.")
          EXIT
        CASE IDC_BTN_5
        CASE IDCANCEL
          MessageBoxQuit()
          EXIT
        CASE IDC_BTN_6
          MessageBoxInfo("Button 6 was pressed.")
          EXIT
      ENDSWITCH

    ELSEIF nMsg == 16 //WM_CLOSE
      MessageBoxQuit()
      RETURN 1
    ENDIF

  ELSEIF IsWindowDefined("Form2") .and. (nHWnd == GetProperty("Form2", "HANDLE"))
    IF nMsg == 43 //WM_DRAWITEM
      IF nWParam == IDC_BTN_OK
        OBTN_Draw(nHWnd, nWParam, nLParam)
      ENDIF

    ELSEIF nMsg == 273 //WM_COMMAND
      nID := LoWord(nWParam)

      IF (nID == IDC_BTN_OK) .or. (nID == IDCANCEL) .or. (nID == IDOK)
        DoMethod("Form2", "RELEASE")
      ENDIF
    ENDIF

  ELSEIF IsWindowDefined("Form3") .and. (nHWnd == GetProperty("Form3", "HANDLE"))
    IF nMsg == 43 //WM_DRAWITEM
      IF (nWParam == IDC_BTN_YES) .or. (nWParam == IDC_BTN_NO)
        OBTN_Draw(nHWnd, nWParam, nLParam)
      ENDIF

    ELSEIF nMsg == 273 //WM_COMMAND
      nID := LoWord(nWParam)

      IF nID == IDOK
        nID := GetDlgCtrlID(GetFocus())
      ENDIF

      SWITCH nID
        CASE IDC_BTN_YES
          Form1.RELEASE
          EXIT
        CASE IDC_BTN_NO
        CASE IDCANCEL
          DoMethod("Form3", "RELEASE")
          EXIT
      ENDSWITCH
    ENDIF
  ENDIF

RETURN NIL


FUNCTION MoveButton(cForm, nID)
  LOCAL aPos

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    aPos    := OBTN_Pos(cForm, nID)
    aPos[2] := If(aPos[2] == 20, 210, 20)
    OBTN_Pos(cForm, nID, aPos[1], aPos[2], aPos[3], aPos[4])
  ENDIF

RETURN NIL


FUNCTION ResizeButton(cForm, nID)
  LOCAL aPos

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    aPos    := OBTN_Pos(cForm, nID)
    aPos[3] := If(aPos[3] == 120, 140, 120)
    OBTN_Pos(cForm, nID, aPos[1], aPos[2], aPos[3], aPos[4])
  ENDIF

RETURN NIL


FUNCTION ShowButton(cForm, nID, lShow)

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    OBTN_Visible(cForm, nID, lShow)
  ENDIF

RETURN NIL


FUNCTION EnableButton(cForm, nID, lShow)

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    OBTN_Enable(cForm, nID, lShow)
  ENDIF

RETURN NIL


FUNCTION ChangeButtonShape(cForm, nID)
  LOCAL nShape

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    nShape := OBTN_Shape(cForm, nID)

    SWITCH nID
      CASE IDC_BTN_1
        nShape := If(nShape == 0, 8, 0)
        EXIT
      CASE IDC_BTN_2
        nShape := If(nShape == 0, 8, 0)
        EXIT
      CASE IDC_BTN_3
        nShape := If(nShape == 0, 30, 0)
        EXIT
      CASE IDC_BTN_4
        nShape := If(nShape == 0, 8, 0)
        EXIT
      CASE IDC_BTN_5
      CASE IDC_BTN_6
        nShape := If(nShape == 0, -1, 0)
        EXIT
    ENDSWITCH

    OBTN_Shape(cForm, nID, nShape, .T.)
  ENDIF

RETURN NIL


FUNCTION ChangeButtonCaption(cForm, nID)
  LOCAL cCaption

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    cCaption := OBTN_Caption(cForm, nID)
    OBTN_Caption(cForm, nID, If(HMG_IsLower(cCaption), HMG_Upper(cCaption), HMG_Lower(cCaption)))
  ENDIF

RETURN NIL


FUNCTION ChangeButtonCaptionAlign(cForm, nID)
  LOCAL cAlign

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    cAlign := OBTN_CaptionAlign(cForm, nID)

    SWITCH cAlign
      CASE "CC"
        cAlign := "LT"
        EXIT
      CASE "LT"
        cAlign := "RT"
        EXIT
      CASE "RT"
        cAlign := "RB"
        EXIT
      CASE "RB"
        cAlign := "LB"
        EXIT
      CASE "LB"
        cAlign := "CT"
        EXIT
      CASE "CT"
        cAlign := "RC"
        EXIT
      CASE "RC"
        cAlign := "CB"
        EXIT
      CASE "CB"
        cAlign := "LC"
        EXIT
      CASE "LC"
        cAlign := "CC"
        EXIT
    ENDSWITCH

    OBTN_CaptionAlign(cForm, nID, cAlign, .T.)
  ENDIF

RETURN NIL


FUNCTION ChangeButtonFont(cForm, nID)
  LOCAL aFont

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    aFont    := OBTN_Font(cForm, nID)
    aFont[2] := If(aFont[2] == 9, 11, 9)
    aFont[3] := If(aFont[3], .F., .T.)

    OBTN_Font(cForm, nID, aFont, .T.)
  ENDIF

RETURN NIL


FUNCTION SetFocusToButton(cForm, nID)

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSEIF ! OBTN_Visible(cForm, nID)
    MessageBoxInfo("Button is hidden!")
  ELSEIF ! OBTN_Enable(cForm, nID)
    MessageBoxInfo("Button is disabled!")
  ELSE
    OBTN_Focus(cForm, nID, .T.)
  ENDIF

RETURN NIL


FUNCTION ReleaseButton(cForm, nID)

  IF OBTN_Handle(cForm, nID) == 0
    MessageBoxInfo("Button does not exist!")
  ELSE
    OBTN_Release(cForm, nID)
  ENDIF

RETURN NIL


FUNCTION ChangeButtonColorAll(cForm, nColor)
  LOCAL nID
  LOCAL aColor

  FOR nID := IDC_BTN_1 TO IDC_BTN_5
    IF OBTN_Handle(cForm, nID) != 0
      IF nColor == 1
        aColor := {{0xFF0000, 0x000000, 0x00FFFF, 0x0090C0, 0}, NIL, {0x0000FF, 0x000000, 0x00FF00, 0x00A000, 0}}
      ELSEIF nColor == 2
        aColor := {{0xFF0000, 0x000000, 0x0090C0, 0x00FFFF, 2}, NIL, {0x0000FF, 0x000000, 0x00A000, 0x00FF00, 2}}
      ELSEIF nColor == 3
        aColor := {{0x0000FF, 0x000000, 0xFFF040, 0xFFC040, 0}, NIL, {0x00FF00, 0x000000, 0x0000FF, 0x000080, 0}}
      ELSE
        aColor := {{0x0000FF, 0x000000, 0xFFC040, 0xFFF040, 2}, NIL, {0x00FF00, 0x000000, 0x000080, 0x0000FF, 2}}
      ENDIF

      OBTN_Color(cForm, nID, aColor, .T.)
    ENDIF
  NEXT

  IF OBTN_Handle(cForm, IDC_BTN_6) != 0
    IF nColor == 1
      aColor := {{0xFF0000, 0x000000, 0, 0, 0, "MUSIC1E"}, {NIL, NIL, 0, 0, 0, "MUSIC1D"}, {0x0000FF, 0x000000, 0, 0, 0, "MUSIC1F"}}
    ELSEIF nColor == 2
      aColor := {{0xFF0000, 0x000000, 0, 0, 0, "MUSIC2E"}, {NIL, NIL, 0, 0, 0, "MUSIC2D"}, {0x0000FF, 0x000000, 0, 0, 0, "MUSIC2F"}}
    ELSEIF nColor == 3
      aColor := {{0xFF0000, 0x000000, 0, 0, 0, "MUSIC3E"}, {NIL, NIL, 0, 0, 0, "MUSIC3D"}, {0x0000FF, 0x000000, 0, 0, 0, "MUSIC3F"}}
    ELSE
      aColor := {{0xFF0000, 0x000000, 0, 0, 0, "MUSIC4E"}, {NIL, NIL, 0, 0, 0, "MUSIC4D"}, {0x0000FF, 0x000000, 0, 0, 0, "MUSIC4F"}}
    ENDIF

    OBTN_Color(cForm, IDC_BTN_6, aColor, .T.)
  ENDIF

  IF HB_IsNIL(aColor)
    MessageBoxInfo("All buttons are released!")
  ENDIF

RETURN NIL


FUNCTION MessageBoxInfo(cInfo)
  LOCAL aBtnFont := {"Arial", 9, .F., .F., .F., .F.}

  DEFINE WINDOW Form2;
    WIDTH  190;
    HEIGHT 120;
    TITLE  Form1.TITLE;
    MODAL;
    NOSIZE

    DEFINE LABEL Msg_LA
      ROW     15
      COL     15
      WIDTH  170
      HEIGHT  13
      VALUE  cInfo
    END LABEL
  END WINDOW

  OBTN_Create("Form2", IDC_BTN_OK, "OK", 50,  50, 80,  26, .T., .T., .T.,  8, {{0x000000, 0x000000, 0xFFFFFF, 0xAAAAAA, 0}, NIL, {0x000000, 0xFFA060, 0xFFFFFF, 0xAAAAAA, 0}}, aBtnFont)

  CENTER WINDOW Form2 IN Form1
  Form2.ACTIVATE

RETURN NIL


FUNCTION MessageBoxQuit()
  LOCAL aBtnFont := {"Arial", 9, .T., .F., .F., .F.}

  DEFINE WINDOW Form3;
    WIDTH  200;
    HEIGHT 120;
    TITLE  Form1.TITLE;
    MODAL;
    NOSIZE

    DEFINE LABEL Msg_LA
      ROW     15
      COL     15
      WIDTH  170
      HEIGHT  13
      VALUE  "Do you want to quit program?"
    END LABEL
  END WINDOW

  OBTN_Create("Form3", IDC_BTN_YES, "Yes", 50,  10, 80,  26, .T., .T., .T.,  8, {{0x0000FF, 0x000000, 0xFFFFFF, 0xAAAAAA, 0}, NIL, {0x0000FF, 0x0080FF, 0xFFFFFF, 0xAAAAAA, 0}}, aBtnFont)
  OBTN_Create("Form3", IDC_BTN_NO,  "No",  50, 100, 80,  26, .T., .T., .T.,  8, {{0x008000, 0x000000, 0xFFFFFF, 0xAAAAAA, 0}, NIL, {0x008000, 0x00FF00, 0xFFFFFF, 0xAAAAAA, 0}}, aBtnFont)

  CENTER WINDOW Form3 IN Form1
  Form3.ACTIVATE

RETURN NIL
